<?php
/*
*******************
Plugin Name: 	Card Helper
Plugin URI: 	http://www.trottyzone.com/product/card-helper
Description: 	Helps customer with gift card
Version: 	1.0
Author: 	Ephrain Marchan
Author URI: 	http://www.trottyzone.com
License: 	GPLv2 or later
********************
*/

/*
------------------------------------------------------------------------------
Card Helper, Copyright (C) 2013 Ephrain Marchan, TrottyZone
-------------------------------------------------------------------------------

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
				*************************************
********************************
---------- NOODLES -------------
********************************
				*************************************
-------------------------------------------------------------------------------
*/

if ( ! defined( 'ABSPATH' ) ) exit;



load_plugin_textdomain('card-helper', false, dirname(plugin_basename(__FILE__)) . '/languages/');

if ( is_admin() ) { 	
 	 add_action( 'admin_menu', 'card_helper_admin_menu' );
	
	add_filter( 'plugin_action_links_'.plugin_basename(__FILE__), 'card_helper_admin_plugin_actions', -10);
	
	add_action( 'admin_init', 'card_helper_register_setting' );
}


function card_helper_admin_menu() {	
    		add_options_page( __('Card Helper', 'card-helper'), __('Card Helper', 'card-helper'), 'manage_options', __FILE__ , 'card_helper__options_page');
}


function card_helper_register_setting() {	
register_setting( 'card_helper_options', 'card_helper_settings', 'card_helper_options_validate' );
}


function card_helper_admin_plugin_actions($links) {
	$card_helper_plugin_links = array(
          '<a href="options-general.php?page=card-helper/card-helper.php">'.__('Settings').'</a>',
           '<a href="http://www.trottyzone.com/forums/forum/website-support/">'.__('Support').'</a>', 
                             );
	return array_merge( $card_helper_plugin_links, $links );
}

function card_helper_options_validate( $input ) {
$options = get_option( 'card_helper_settings' );
	foreach( $input['buttons'] as $i => $btn ) :
		if ( empty( $btn['label'] ) ) 
			unset( $input['buttons'][$i], $btn );
				
	endforeach;
	$input['buttons'] = array_values( $input['buttons'] );

return $input;
}

function card_helper__options_page() {
$options = get_option( 'card_helper_settings' );

$card_helper_hidden_name = 'card_helper_submit_hidden';

$hidden_reset2_card_helper = "field_hidden_reset_card_helper";

if( isset($_POST[ $hidden_reset2_card_helper ]) && $_POST[ $hidden_reset2_card_helper ] == 'Y' ) {

add_option( 'reset_cardhelper1', $options['force']['title'] );
add_option( 'reset_cardhelper2', $options['force']['field'] );
add_option( 'reset_cardhelper3', $options['force']['height'] );
add_option( 'reset_cardhelper4', $options['force']['height2'] );
add_option( 'reset_cardhelper5', $options['force']['width'] );
add_option( 'reset_cardhelper6', $options['force']['width2'] );

update_option( 'reset_cardhelper1', $options['force']['title'] );
update_option( 'reset_cardhelper2', $options['force']['field'] );
update_option( 'reset_cardhelper3', $options['force']['height'] );
update_option( 'reset_cardhelper4', $options['force']['height2'] );
update_option( 'reset_cardhelper5', $options['force']['width'] );
update_option( 'reset_cardhelper6', $options['force']['width2'] );

delete_option('card_helper_settings');

$defaults_card_helper = array( 
                           'force' => array( 
		           'title' => get_option('reset_cardhelper1'),
		           'field' => get_option('reset_cardhelper2'),
		           'height' => get_option('reset_cardhelper3'),
		           'height2' => get_option('reset_cardhelper4'),
		           'width' => get_option('reset_cardhelper5'),
		           'width2' => get_option('reset_cardhelper6') )
          );

	add_option( 'card_helper_settings', $defaults_card_helper );

header('Location: '.$_SERVER['REQUEST_URI'] );
}

if( isset($_POST[ $card_helper_hidden_name ]) && $_POST[ $card_helper_hidden_name ] == 'Y' ) {

update_option( 'card_helper_settings', $options );
}
	echo '<div class="wrap">';
	echo '<div id="icon-themes" class="icon32"><br></div>';
	echo '<h2>'.__('Card Helper', 'card-helper').'</h2>'; 



// -------------------------------------------------------- CLEAR ------------------------------------------->

			if (isset($_FILES['import']) && check_admin_referer('ie-import')) {
				if ($_FILES['import']['error'] > 0) {
					wp_die("Error happens");
				}
				else {
				
				$encode_options = $_FILES['import']['tmp_name'];

	$row = 1;
if (($handle = fopen( $encode_options , "r")) !== FALSE) {
    while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
        $num = count($data);
        $row++;

	for ($c=0; $c < $num; $c++) {
	$checkerstuffx = ( count( $options['buttons'] ) - 1 ) + $row;

	if ( $c == 0 ) { // label
	$options[buttons][$checkerstuffx][label] = $data[$c];
	}

	if ( $c == 1 ) { // value
	$options[buttons][$checkerstuffx - 1][value] = $data[$c];
	}

	if ( $c == 2 ) { // type
	$options[buttons][$checkerstuffx - 1][type] = $data[$c];
	}

	update_option( 'card_helper_settings', $options );
        }

        
    }
    fclose($handle);
}

					
					
				}}
		?>
		
		<form method='post' enctype='multipart/form-data'>
			<p class="submit">
				<?php wp_nonce_field('ie-import'); ?>
				<input type='file' name='import' />
				<input type='submit' class="button-secondary" name='submit' value='<?php _e('Import CSV', 'card-helper'); ?>' />
			</p>
		</form>
	


<!-------------------------------------------------------- CLEAR ---------------------------------->

<form name="reset_form" method="post" action="">
	<input type="hidden" name="<?php echo $hidden_reset2_card_helper; ?>" value="Y">
	<input type="submit" name="submit" id="card_helper_reset_submit" class="button-secondary" value="Reset">
</form>

<div class="button-secondary css_button"><?php _e('Custom CSS','card-helper'); ?></div>

<form name="form" method="post" action="options.php" id="card_helper_form">

<?php settings_fields( 'card_helper_options' );
			$options = get_option( 'card_helper_settings' ); ?>

<input type="submit" name="Submit" class="submit2_card_helper button-primary" value="<?php esc_attr_e('Save Changes','card-helper') ?>" />

<table border="1" class="widefat toggle_css" style="display:none;">

<thead>
	<tr>
		<th><?php _e('Custom CSS Field','card-helper'); ?></th>
</tr>
</thead>
	<tbody>
	<tr valign="top">

<td><textarea type="text" name="card_helper_settings[force][custom_css]" placeholder="<?php _e('My Field Description','card-helper'); ?>"><?php echo esc_attr( $options['force']['custom_css'] ); ?></textarea></td>

</tr>
	</tbody>
</table>


<table class="widefat" border="1">

<thead>
	<tr>
				<th><?php _e('Reset Title','card-helper'); ?></th>
				<th><?php _e('Field Name','card-helper'); ?></th>
				<th><?php _e('Right Container Exterior Height','card-helper'); ?></th>
				<th><?php _e('Right Container Interior Height','card-helper'); ?></th>
				<th><?php _e('Right Container Width (%)','card-helper'); ?></th>
				<th><?php _e('Left Container Width (%)','card-helper'); ?></th>
	</tr>
</thead>
	<tbody>
	<tr valign="top">

			<input type="hidden" name="<?php echo $card_helper_hidden_name; ?>" value="Y">

<td><input type="text" name="card_helper_settings[force][title]" placeholder="<?php _e('My Reset Name', 'card-helper'); ?>" value="<?php echo esc_attr( $options['force']['title'] ); ?>" /></td>

<td><input type="text" name="card_helper_settings[force][field]" placeholder="<?php _e('My Field Name', 'card-helper'); ?>" value="<?php echo esc_attr( $options['force']['field'] ); ?>" /></td>

<td><input type="text" name="card_helper_settings[force][height]" placeholder="273" value="<?php echo str_replace('px','', $options['force']['height']); ?>" /></td>

<td><input type="text" name="card_helper_settings[force][height2]" placeholder="234" value="<?php echo str_replace('px','',$options['force']['height2']); ?>" /></td>

<td><input type="text" name="card_helper_settings[force][width]" placeholder="31%" value="<?php echo esc_attr( $options['force']['width'] ); ?>" /></td>

<td><input type="text" name="card_helper_settings[force][width2]" placeholder="63%" value="<?php echo esc_attr( $options['force']['width2'] ); ?>" /></td>

	</tr>
	</tbody>
</table>

<table class="widefat" border="1">

<thead>
	<tr>
		<th><?php _e('Field Description','card-helper'); ?></th>
</tr>
</thead>
	<tbody>
	<tr valign="top">

<td><input type="text" name="card_helper_settings[force][description]" placeholder="<?php _e('My Field Description','card-helper'); ?>" value="<?php echo esc_attr( $options['force']['description'] ); ?>" /></td>

</tr>
	</tbody>
</table>


<style type="text/css">
td.tag input {
        width: 96%;
}
.card-helper-clone {
	display:none;
}
.widefat input {
	width:100%;
}
.card-helper-order {
	cursor:move;
}
.button-secondary.css_button {
        float: left;
        margin-left: 20px;
}
.widefat.toggle_css textarea {
	width: 100%;
	height: 300px;
}
.submit2_card_helper.button-primary {
	width: inherit;
	margin-left: 20px;
	float: left;
        margin-bottom: 20px;
}
#card_helper_reset_submit {
	width: inherit;
	float: left;
}
.card-helper-table > tbody > tr > td {
	background: #fff;
    	border-right: 1px solid #ededed;
    	border-bottom: 1px solid #ededed;
    	padding: 8px;
    	position: relative;
}

.card-helper-table > tbody > tr:last-child td { border-bottom: 0 none; }
.card-helper-table > tbody > tr td:last-child { border-right: 0 none; }
.card-helper-table > thead > tr > th { border-right: 1px solid #e1e1e1; }
.card-helper-table > thead > tr > th:last-child { border-right: 0 none; }

.card-helper-table tr td.card-helper-order,
.card-helper-table tr th.card-helper-order {
	width: 16px;
	text-align: center;
	vertical-align: middle;
	color: #aaa;
	text-shadow: #fff 0 1px 0;
}

.card-helper-table .card-helper-remove {
	width: 16px;
	vertical-align: center;
	font-size: 20px;
}
.card-helper-table input[type="text"] {
	width: 100%;
}

.card-helper-table-footer {
	position: relative;
	overflow: hidden;
	margin-top: 10px;
	padding: 8px 0;
}
.value textarea {
width: 94%;
}
</style>

<table class="widefat card-helper-table" border="1" style="margin-top:20px;">

<thead>
	<tr>
				<th style="width:1%;" class="card-helper-order" title="<?php esc_attr_e( 'Change order' , 'card-helper' ); ?>"></th>

				<th class="label"><?php _e('Label' , 'card-helper' ); ?></th>

				<th class="value"><?php _e('Value to be transferred' , 'card-helper' ); ?></th>

				<th class="type" width="10%"><?php _e('Type' , 'card-helper' ); ?></th>

 				<th width="1%" scope="col" title="<?php esc_attr_e( 'Remove button', 'card-helper' ); ?>"><!-- remove --></th>		
	</tr>
</thead>

					<tbody>
<?php if ( isset ( $options['buttons'] ) ) :
                	for ( $i = 0; $i < count( $options['buttons'] ); $i++ ) :
                		if ( ! isset( $options['buttons'][$i] ) )
                			break; ?>

   			<tr valign="top" class="card-helper-row">
<td class="card-helper-order" title="<?php esc_attr_e( 'Change order', 'card-helper' ); ?>"><?php echo $i + 1; ?></td>

<input type="hidden" name="<?php echo $card_helper_hidden_name; ?>" value="Y">

<td class="label"><input type="text" name="card_helper_settings[buttons][<?php echo $i; ?>][label]" placeholder="<?php _e('My title', 'card-helper'); ?>" value="<?php echo esc_attr( $options['buttons'][$i][label] ); ?>" /></td>

<td class="value"><input type="text" name="card_helper_settings[buttons][<?php echo $i; ?>][value]" placeholder="<?php _e('Example red', 'card-helper'); ?>" value="<?php echo esc_attr( $options['buttons'][$i][value] ); ?>" /></td>

<td class="type"><input type="text" name="card_helper_settings[buttons][<?php echo $i; ?>][type]" placeholder="<?php _e('Modern', 'card-helper'); ?>" value="<?php echo esc_attr( $options['buttons'][$i][type] ); ?>" /></td>

<td class="card-helper-remove"><a class="card-helper-remove-button" href="javascript:;" title="<?php esc_attr_e( 'Remove Field' , 'card-helper' ); ?>">&times;</a></td>
   			</tr>

<?php endfor; endif; ?>
<!-- Empty -->

                    <?php $i = 999; ?>

			<tr valign="top" class="card-helper-clone" >

<td class="card-helper-order" title="<?php esc_attr_e( 'Change order' , 'card-helper' ); ?>"><?php echo $i; ?></td>

<input type="hidden" name="<?php echo $card_helper_hidden_name; ?>" value="Y">

<td class="label"><input placeholder="My title" type="text" name="card_helper_settings[buttons][<?php echo $i; ?>][label]" title="<?php esc_attr_e( 'Label of the New Field', 'card-helper' ); ?>" value="" /></td>

<td class="value"><input type="text" name="card_helper_settings[buttons][<?php echo $i; ?>][value]" placeholder="<?php _e('Example red', 'card-helper'); ?>" title="<?php esc_attr_e( 'Value to be transferred', 'card-helper' ); ?>" /></td>

<td class="type"><input type="text" name="card_helper_settings[buttons][<?php echo $i; ?>][type]" placeholder="<?php _e('Modern', 'card-helper'); ?>" title="<?php esc_attr_e( 'Type', 'card-helper' ); ?>" value="" /></td>

<td class="card-helper-remove"><a class="card-helper-remove-button" href="javascript:;" title="<?php esc_attr_e( 'Remove Field' , 'card-helper' ); ?>">&times;</a></td>

  			 </tr>
					</tbody>

</table>
<div class="card-helper-table-footer">

			<a href="javascript:;" id="card-helper-add-button" class="button-secondary"><?php _e( '+ Add New Field' , 'card-helper' ); ?></a>

</div>


</form>
<?php

}



add_action('woocommerce_after_checkout_shipping_form', 'out_pre_card_helper');
function out_pre_card_helper() {
$options = get_option( 'card_helper_settings' );


do_action( 'card_helper_preview_hook');

wp_enqueue_style('card_helper', plugins_url('card-helper/card_helper.css') );
wp_enqueue_script('card_helper-js', plugins_url('card-helper/extend_card_helper.js') );

?>
<style type="text/css">
#card-helper-float-right {
        width: <?php if ( !empty($options['force']['width']) ) { echo $options['force']['width']; } else { echo '44%'; } ?>;
	height: <?php if ( !empty($options['force']['height']) ) { echo str_replace('px','',$options['force']['height']); } else { echo '225'; } ?>px;
}
#card-helper-float-right .scroller-content {
	height: <?php if ( !empty($options['force']['height2']) ) { echo str_replace('px','',$options['force']['height2']); } else { echo '180'; } ?>px;
}
#card-helper-float-left {
	width: <?php if ( !empty($options['force']['width2']) ) { echo $options['force']['width2']; } else { echo '49%'; } ?>;
}
#card-helper-float-left textarea {
       height: <?php if ( !empty($options['force']['height']) ) { echo str_replace('px','',$options['force']['height']) - 12; } else { echo '212'; } ?>px;
}
</style>


<label for="<?php echo str_replace(' ', '_', $options['force']['field'] ); ?>" class="card-helper-label"><h3 class="card-helper-title"><?php echo $options['force']['field']; ?></h3><p><?php echo esc_attr($options['force']['description']); ?></p></label>

<div id="card-helper-wrapper">

	<div id="card-helper-float-left">

<p>
<textarea class="input-text" type="text" name="chtrrezxwq" id="chtrrezxwq"></textarea>
</p>


	</div>

		<div id="card-helper-float-right">

			<div id="top-align">
<select name="filter_select" id="filter_select" value="">
<option value="show_all_now" class="return_default_select"><?php echo $options['force'][title]; ?></option>


<?php
			$options = get_option( 'card_helper_settings' );
				if ( count( $options['buttons'] ) > 0 ) : 
						$i = 0;

							// Loop through each button
							foreach ( $options['buttons'] as $btn ) :

								$label = ( isset( $btn['label'] ) ) ? $btn['label'] : ''; 
 ?>

     <option value="<?php echo $btn['type']; ?>" class="select-option<?php echo $i; ?>"><?php echo $btn['type']; ?></option>

<?php 
 $i++;
					endforeach;
endif;
?>
</select>	
   		
			</div>
<div class="scroller-content">
				<table id="bottom-align">
<tbody>
<?php
			$options = get_option( 'card_helper_settings' );
				if ( count( $options['buttons'] ) > 0 ) : 
						$i = 0;

							// Loop through each button
							foreach ( $options['buttons'] as $btn ) :

								$label = ( isset( $btn['label'] ) ) ? $btn['label'] : ''; ?>


	<tr><td class="select-title <?php echo $i; ?>_onclickcard <?php echo str_replace(' ', '', $btn['type']); ?>_filter"><?php echo $btn['label']; ?></td></tr>

<?php $i++;
					endforeach;
endif;
 ?>
				</tbody></table>​</div>
		</div>
</div>
</p>
<?php
}


add_action('card_helper_preview_hook', 'card_helper_scripts');
function card_helper_scripts() {
$options = get_option( 'card_helper_settings' );

?>
<script type="text/javascript">
jQuery(document).ready(function() {
<?php
				if ( count( $options['buttons'] ) > 0 ) : 
						$i = 0;

							// Loop through each button
							foreach ( $options['buttons'] as $btn ) :

								$label = ( isset( $btn['label'] ) ) ? $btn['label'] : ''; 

?>
jQuery('.select-title.<?php echo $i; ?>_onclickcard').click(function(){
var txt = "<?php echo preg_replace('/\s+/', ' ', $btn['value']); ?>";

jQuery( ".select-title" ).removeClass('current');
jQuery( ".select-title.<?php echo $i; ?>_onclickcard" ).addClass( "current" );
    jQuery( "textarea#chtrrezxwq" ).val( txt );

}); 

<?php 
$i++;
					endforeach;
?>
});
</script>
<?php
endif;
}



add_action('card_helper_preview_hook', 'filter_connection');
function filter_connection() {
$options = get_option( 'card_helper_settings' );
?>
<script type="text/javascript">
jQuery(document).ready(function() {

jQuery('select[name="filter_select"]').change(function() {
<?php
				if ( count( $options['buttons'] ) > 0 ) : 
						$i = 0;

							// Loop through each button
							foreach ( $options['buttons'] as $btn ) :

								$label = ( isset( $btn['label'] ) ) ? $btn['label'] : ''; ?>


if (jQuery(this).val() == "<?php echo $btn['type']; ?>") {

jQuery('.select-title').hide();
jQuery('.select-title.<?php echo str_replace(' ', '', $btn['type']); ?>_filter').show();
}

<?php $i++;
					endforeach;
endif;
?>
}); 
});
</script>
<?php
}


function card_helper_ui( $hook_suffix ) {
	if ( $hook_suffix == 'settings_page_card-helper/card-helper' ) {
		
		wp_enqueue_script( 'card-helper-j', plugins_url( 'card_helper.js', __FILE__ ), array( 'jquery' ), '1.2' );
		if(!wp_script_is('jquery-ui-sortable', 'queue')){
                wp_enqueue_script('jquery-ui-sortable');
                     }
	}
}

add_action( 'admin_enqueue_scripts', 'card_helper_ui' );

// update post meta
add_action('woocommerce_checkout_update_order_meta', 'update_card_helper');
function update_card_helper( $order_id) {
global $woocommerce;
$options = get_option( 'card_helper_settings' );
 $order = new WC_Order( $order_id );

    if ($_POST['chtrrezxwq']) {
update_post_meta( $order_id, ''.$options['force']['field'].'', esc_attr($_POST['chtrrezxwq']));
}

}

add_action( 'woocommerce_email_after_order_table', 'email_show_card_helper', 15 );
function email_show_card_helper($order) {
$options = get_option( 'card_helper_settings' );
    echo '<p><strong>'.$options['force']['field'].':</strong> <br>' . nl2br($order->order_custom_fields[''.$options['force']['field'].''][0]). '</p>';
}

add_action( 'woocommerce_order_details_after_order_table', 'order_details_show_card_helper' );
function order_details_show_card_helper($order) {
$options = get_option( 'card_helper_settings' );
    echo '<dt>'.$options['force']['field'].':</dt><dd>' . nl2br($order->order_custom_fields[''.$options['force']['field'].''][0]). '</dd>';
}

add_action('wp_head','custom_css_card_helper');
function custom_css_card_helper() {
$options = get_option('card_helper_settings');
if ( is_checkout() ) {
?>
<style type="text/css">
<?php echo $options[force][custom_css]; ?>
</style>
<?php
}}